package j3d_lib;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: Borland Software Corporation</p>
 * 3D Engine Programmer - Zabolotnov Vadim Alexandrovich aka Nick-85
 * System Programmer - ? aka Grafmoto
 * Tester - ? aka Hobbit19
 * @version 1.0
 */

public class AffineTrans {

  // Fields
  public int m00;
  public int m01;
  public int m02;
  public int m03;
  public int m10;
  public int m11;
  public int m12;
  public int m13;
  public int m20;
  public int m21;
  public int m22;
  public int m23;

  // Constructors
  public AffineTrans()
  {
    m00 = m01 = m02 = m03 =
    m10 = m11 = m12 = m13 =
    m20 = m21 = m22 = m23 = 0;
  }
  public AffineTrans( int[][] m )
  {
    m00 = m[0][0]; m01 = m[0][1]; m02 = m[0][2]; m03 = m[0][3];
    m10 = m[1][0]; m11 = m[1][1]; m12 = m[1][2]; m13 = m[1][3];
    m20 = m[2][0]; m21 = m[2][1]; m22 = m[2][2]; m23 = m[2][3];
  }

  // Methods
  public void set( int[][] m )
  {
    m00 = m[0][0]; m01 = m[0][1]; m02 = m[0][2]; m03 = m[0][3];
    m10 = m[1][0]; m11 = m[1][1]; m12 = m[1][2]; m13 = m[1][3];
    m20 = m[2][0]; m21 = m[2][1]; m22 = m[2][2]; m23 = m[2][3];
  }

  public void multiply( AffineTrans t )
  { //  04.11.05 (17:13)     
    //   ,     , 
    int	        M00, M01, M02, M03,
                M10, M11, M12, M13,
                M20, M21, M22, M23;

    M00 = m00*t.m00 + m10*t.m01 + m20*t.m02;
    M10 = m00*t.m10 + m10*t.m11 + m20*t.m12;
    M20 = m00*t.m20 + m10*t.m21 + m20*t.m22;

    M01 = m01*t.m00 + m11*t.m01 + m21*t.m02;
    M11 = m01*t.m10 + m11*t.m11 + m21*t.m12;
    M21 = m01*t.m20 + m11*t.m21 + m21*t.m22;

    M02 = m02*t.m00 + m12*t.m01 + m22*t.m02;
    M12 = m02*t.m10 + m12*t.m11 + m22*t.m12;
    M22 = m02*t.m20 + m12*t.m21 + m22*t.m22;

    M03 = m03*t.m00 + m13*t.m01 + m23*t.m02;
    M13 = m03*t.m10 + m13*t.m11 + m23*t.m12;
    M23 = m03*t.m20 + m13*t.m21 + m23*t.m22;

    m00 = M00;   m01 = M01;   m02 = M02;   m03 = M03;
    m10 = M10;   m11 = M11;   m12 = M12;   m13 = M13;
    m20 = M20;   m21 = M21;   m22 = M22;   m23 = M23;

  }

  public void multiply( AffineTrans t1, AffineTrans t2 )
  { //  04.11.05 (17:13)     
    //   ,     , 
    m00 = t1.m00*t2.m00 + t1.m10*t2.m01 + t1.m20*t2.m02;
    m10 = t1.m00*t2.m10 + t1.m10*t2.m11 + t1.m20*t2.m12;
    m20 = t1.m00*t2.m20 + t1.m10*t2.m21 + t1.m20*t2.m22;

    m01 = t1.m01*t2.m00 + t1.m11*t2.m01 + t1.m21*t2.m02;
    m11 = t1.m01*t2.m10 + t1.m11*t2.m11 + t1.m21*t2.m12;
    m21 = t1.m01*t2.m20 + t1.m11*t2.m21 + t1.m21*t2.m22;

    m02 = t1.m02*t2.m00 + t1.m12*t2.m01 + t1.m22*t2.m02;
    m12 = t1.m02*t2.m10 + t1.m12*t2.m11 + t1.m22*t2.m12;
    m22 = t1.m02*t2.m20 + t1.m12*t2.m21 + t1.m22*t2.m22;

    m03 = t1.m03*t2.m00 + t1.m13*t2.m01 + t1.m23*t2.m02;
    m13 = t1.m03*t2.m10 + t1.m13*t2.m11 + t1.m23*t2.m12;
    m23 = t1.m03*t2.m20 + t1.m13*t2.m21 + t1.m23*t2.m22;
  }

  public void rotationX( int a )
  { //        -   ...
    //  04.11.05 (17:13)      
    int sin_a, cos_a;
    sin_a        =  com.motorola.graphics.j3d.Util3D.sin( a );
    cos_a        =  com.motorola.graphics.j3d.Util3D.cos( a );
    m00 = 1 << 12;       m01 = 0;            m02 = 0;
    m10 = 0;             m11 = cos_a;        m12 = -sin_a;
    m20 = 0;             m21 = sin_a;        m22 =  cos_a;
  }

  public void rotationY( int a )
  { //        -   ...
    //  04.11.05 (17:13)      
    int sin_a, cos_a;
    sin_a        =  com.motorola.graphics.j3d.Util3D.sin( a );
    cos_a        =  com.motorola.graphics.j3d.Util3D.cos( a );
    m00 =  cos_a;      m01 = 0;              m02 = sin_a;
    m10 = 0;           m11 = 1 << 12;        m12 = 0;
    m20 = -sin_a;      m21 = 0;              m22 = cos_a;
  }

  public void rotationZ( int a )
  { //        -   ...
    //  04.11.05 (17:13)      
    int sin_a, cos_a;
    sin_a        =  com.motorola.graphics.j3d.Util3D.sin( a );
    cos_a        =  com.motorola.graphics.j3d.Util3D.cos( a );
    m00 = cos_a;       m01 = -sin_a;         m02 = 0;
    m10 = sin_a;       m11 =  cos_a;         m12 = 0;
    m20 = 0;           m21 = 0;              m22 = 1 << 12;
  }

  public void rotationV( Vector3D v, int a )
  { //  04.11.05 (17:13)      
    int c, s, k;
    v.unit();
    c = com.motorola.graphics.j3d.Util3D.cos( a );
    s = com.motorola.graphics.j3d.Util3D.sin( a );
    k = 1 - c;
    m00 = v.x*v.x*k + c;       m01 = v.y*v.x*k - v.z*s; m02 = v.x*v.z*k + v.y*s;
    m10 = v.y*v.x*k + v.z*s;   m11 = v.y*v.y*k + c;     m12 = v.y*v.z*k - v.x*s;
    m20 = v.x*v.z*k - v.y*s;   m21 = v.y*v.z*k + v.x*s; m22 = v.z*v.z*k + c;
  }

  public void setViewTrans( Vector3D position, Vector3D look, Vector3D up )
  { //  04.11.05 (17:13)    Vector3D::unit()     
    //   ,     , 

    Vector3D u, v, n = new Vector3D();

    n.x = position.x - look.x;
    n.y = position.y - look.y;
    n.z = position.z - look.z;              n.unit();
    u = Vector3D.outerProduct( n, up );     u.unit();
    v = Vector3D.outerProduct( n, u  );     v.unit();
    //  04.11.05 (17:13)  unit       

    m00 = u.x;       m01 = u.y;         m02 = u.z;
    m10 = v.x;       m11 = v.y;         m12 = v.z;
    m20 = n.x;       m21 = n.y;         m22 = n.z;

    m03 = - ( u.x * position.x + u.y * position.y + u.z * position.z ) >> 12; //    4098 ( >> 12 )
    m13 = - ( v.x * position.x + v.y * position.y + v.z * position.z ) >> 12; //    4098 ( >> 12 )
    m23 = - ( n.x * position.x + n.y * position.y + n.z * position.z ) >> 12; //    4098 ( >> 12 )
  }

  public Vector3D transPoint( Vector3D src )
  { //
    //  04.11.05 (17:13)     
    //
    //     ,     - 
    //         32767,
    //         ,
    //         
    //     .
    //
    //   ,     , 
    //
    Vector3D vres = new Vector3D();
    m03 = ( m00 * src.x + m01 * src.y + m02 * src.z ) >> 12 + m03; //    
    m13 = ( m10 * src.x + m11 * src.y + m12 * src.z ) >> 12 + m13; //    
    m23 = ( m20 * src.x + m21 * src.y + m22 * src.z ) >> 12 + m23; //    
    return vres;
  }
}